dashboardPage(
  #dashboardHeader(title = paste0(gene, "/", drug)),
  dashboardHeader(title = "Sequence Alignment"),
  
  dashboardSidebar(
    sidebarMenu( id = "sidebar",
                 selectInput(
                   "switch_target",
                   label="Target",
                   choices = c(
                     "alr",
                     "embb",
                     "gid",
                     "katg",
                     "pnca",
                     "rpob"
                   ),
                   selected="embb"),
                 menuItem("LogoP ED", tabName="LogoP ED"),
                 
                 sliderInput(
                   "display_position_full_range"
                   , "Display Positions"
                   , min=1, max=150, value=c(1,150)
                 ),
                 
                 conditionalPanel(
                   condition="
                                  input.sidebar == 'LogoP SNP' ||
                                  input.sidebar == 'LogoP OR' ||
                                  input.sidebar == 'LogoP ED'", 
                   selectInput(
                     "logoplot_colour_scheme", 
                     label="Logo Plot Colour Scheme", 
                     choices = logoPlotSchemes, 
                     selected="chemistry"
                   )
                 )
    )
  ),
  body <- dashboardBody(
    
    tabItems(
      tabItem(tabName = "dashboard",
              h2("Dashboard tab content")
      ),
      
      tabItem(tabName = "widgets",
              h2("Widgets tab content")
      )
    ),
    # creates a 'Conditional Panel' containing a plot object from each of our 
    # ggplot plot functions (and its associated data frame)
    fluidRow(
      column(
        width=12,
        plotOutput("LogoPlotMSA",
                   click = "plot_click") %>% withSpinner(color="#0dc5c1")
      )
    )
  )
)